import DCinsideRead.dcinside as dc
from selenium import webdriver
from selenium.webdriver.common.action_chains import ActionChains
from selenium.webdriver.common.keys import Keys
# from selenium.webdriver.support import expected_conditions
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
from selenium.common.exceptions import TimeoutException
import random
import datetime
import time
# import keyboard

random.seed(time.time())
KST = datetime.timezone(datetime.timedelta(hours=9))


# def try_until_success_ignoring_pop_up_and_(func):
#     func_name = func.__name__
#
#     def wrapper(*args, **kwargs):
#         # time.sleep(1)
#         start_time = time.time()
#         while True:
#             if time.time() - start_time > 4:
#                 print("원인은 알 수 없으나 4초 이상 실패하여 함수를 빠져나옵니다")
#                 return
#                 # break
#             try:
#                 result = func(*args, **kwargs)
#             except:
#                 continue
#             else:
#                 return result
#         # return result
#     return wrapper


def execute_driver(disable_gpu=True, headless=False, executable_path=False, google_colab=False, **kwargs):
    # PROXY = "23.23.23.23:3128"  # IP:PORT or HOST:PORT
    if executable_path is False:
        now = datetime.datetime.now(KST)
        print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
        print("chromedriver의 path가 입력되지 않아 함수를 비정상적으로 종료합니다")
        return
    chrome_options = webdriver.ChromeOptions()
    # options = webdriver.FirefoxOptions()
    if google_colab:
        chrome_options.add_argument('--headless')
        chrome_options.add_argument('--no-sandbox')
        chrome_options.add_argument('--disable-dev-shm-usage')
    else:
        if disable_gpu:
            chrome_options.add_argument("disable-gpu")
        if headless:
            chrome_options.add_argument("--headless")

    # proxy_ip = "123.143.203.194"
    # proxy_port = "4145"
    # proxy_string = "--proxy-server=" + proxy_ip + ":" + proxy_port
    # chrome_options.add_argument(proxy_string)

    driver = webdriver.Chrome(options=chrome_options, executable_path=executable_path)
    # driver = webdriver.Firefox(options=options)
    # driver = webdriver.Firefox()
    return driver


# def driver_get_url(driver=0, url=0, *args):
#     driver.get(url)
#     return


def post(gallery_name="프로그래밍", *args,
         whether_login=False,
         user_name="ㅇㅇ", password="rladbtlrgksxpanfdjqhk",
         user_name_password_dictionary=False,
         infinite_loop=False,
         use_default_post_title=False,
         use_default_post_content=True,
         disable_gpu=True, headless=False, executable_path=False,
         google_colab=False,
         **kwargs):

    start_time = time.time()
    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("함수 post 를 시작합니다.")

    if executable_path is False:
        now = datetime.datetime.now(KST)
        print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
        print("chromedriver 의 path 가 입력되지 않아 함수를 비정상적으로 종료합니다")
        return

    page_and_base_url_dictionary = dc.get_page_and_base_url_dictionary(gallery_name)
    driver = execute_driver(disable_gpu=disable_gpu, headless=headless, executable_path=executable_path,
                            google_colab=google_colab)

    # time.sleep(1)

    button_write_xpath = '//*[@id="btn_write"]'
    url_write_page = page_and_base_url_dictionary["url"].replace("lists", "write/")
    user_name_xpath = '//*[@id="name"]'
    password_xpath = '//*[@id="password"]'
    title_xpath = '//*[@id="subject"]'
    button_tx_alignleft_xpath = '//*[@id="tx_alignleft"]'
    button_cancel_xpath = '//*[@id="write"]/div[4]/button[1]'
    button_submit_xpath = '//*[@id="write"]/div[4]/button[2]'
    # button_cancel = driver.find_element_by_xpath(button_cancel_xpath)
    # button_submit = driver.find_element_by_xpath(button_submit_xpath)

    do_while_count = 1
    while do_while_count > 0:
        # driver.implicitly_wait(10)
        # driver.get(page_and_base_url_dictionary["url"])
        # time.sleep(1)
        driver.get(url_write_page)
        WebDriverWait(driver, 10).until(
            EC.presence_of_element_located((By.XPATH, button_submit_xpath))
        )
        # driver.find_element_by_xpath(button_write_xpath).click()
        if use_default_post_title:
            if type(use_default_post_title) is str:
                post_title = use_default_post_title
            else:
                post_title = "ㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋㅋ" + str(random.randint(0, 1000))
        else:
            post_title = input("글 제목을 입력하세요: ")
            post_title += str(random.randint(0, 1000))
            if post_title == "exit":
                break

        if use_default_post_content:
            if type(use_default_post_content) is str:
                post_content = use_default_post_content
            else:
                post_content = str(random.randint(0, 100000000))
        else:
            post_content = input("글 내용을 입력하세요: ")

        if do_while_count == 1:
            driver.find_element_by_xpath('//*[@id="name"]').send_keys(user_name)
            driver.find_element_by_xpath('//*[@id="password"]').send_keys(password)
            do_while_count += 1

        driver.find_element_by_xpath('//*[@id="subject"]').send_keys(post_title)

        # driver.implicitly_wait(10)
        driver.find_element_by_xpath(button_tx_alignleft_xpath).click()

        ActionChains(driver).send_keys(post_content).perform()

        button_submit = driver.find_element_by_xpath(button_submit_xpath)
        ActionChains(driver).move_to_element(button_submit).click().perform()

        try:
            WebDriverWait(driver, 0.5).until(
                EC.alert_is_present()
            )
            alert = driver.switch_to.alert
            alert.accept()
        except TimeoutException:
            pass

        # if driver.switch_to.alert is not None:
        #     driver.switch_to.alert.accpet()
        print("작성한 글 제목:", post_title, "\n")

        if infinite_loop is not True:
            break

    driver.quit()
    driver.close()
    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("함수 post 를 종료합니다")
    print("함수 post 를 끝마치는 데 %.2f초 걸렸습니다" % (time.time() - start_time))
    return

if __name__ == "__main__":
    pass
